﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Cinemachine;

namespace MaskSlap
{
    public class CameraController : MonoBehaviour
    {
        public static CameraController _camera { get; private set; }

        CinemachineVirtualCamera virtualCm;
        CinemachineBasicMultiChannelPerlin virtualCmNoise;

        [SerializeField]
        float shakeDuration = 1f;
        [SerializeField]
        float shakeAmplitude = 1f;

        private void Awake()
        {
            _camera = this;
            virtualCm = GetComponent<CinemachineVirtualCamera>();
            virtualCmNoise = virtualCm.GetCinemachineComponent<CinemachineBasicMultiChannelPerlin>();
        }
        public void Init()
        {
            virtualCm.Follow = FindObjectOfType<Player>().transform;
            virtualCm.LookAt = FindObjectOfType<Player>().transform;
        }
        public void CameraShake()
        {
            if (CameraShakeRoutine != null)
            { currentShakeDuration += (shakeDuration/2); return; }
            CameraShakeRoutine = StartCoroutine(_CR_ShakeRoutine());
        }
        Coroutine CameraShakeRoutine = null;
        float currentShakeDuration = 1f;

        IEnumerator _CR_ShakeRoutine()
        {
            float elapsed = 0;
            virtualCmNoise.m_AmplitudeGain = shakeAmplitude;
            while (true)
            {
                float t = Mathf.Clamp01(elapsed / currentShakeDuration);
                elapsed += Time.deltaTime;
                yield return null;
                if (t >= 1f)
                    break;
            }
            virtualCmNoise.m_AmplitudeGain = 0;
            CameraShakeRoutine = null;
        }
    }
}
