﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using TMPro;

namespace MaskSlap
{
    public class HUDHandler : MonoBehaviour
    {
        public static HUDHandler instance;

        [SerializeField]
        private GameObject  hudObject, gameEndObject;
        [SerializeField]
        private GameObject gameWonObject, gameLostObject;

        [SerializeField]
        private GameObject restartButton;

        [SerializeField]
        private TextMeshProUGUI scoreText;

        private void Awake()
        {
            instance = this;
        }

        public void ShowHUD()
        {
            hudObject.SetActive(true);
            gameEndObject.SetActive(false);
        }

        public void ShowGameEndScreen(bool won)
        {
            hudObject.SetActive(false);
            gameEndObject.SetActive(true);
            gameWonObject.SetActive(won);
            gameLostObject.SetActive(!won);

            UnityEngine.EventSystems.EventSystem.current.SetSelectedGameObject(restartButton);
        }

        public void UpdateSlapScoreOnHUD(int currentSlaps, int totalPoliticians)
        {
            scoreText.text = currentSlaps.ToString() + "/" + totalPoliticians.ToString();
        }
    }
}