﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

namespace MaskSlap
{
    public class SceneLoader : MonoBehaviour
    {
        public string thisScene;
        public List<string> sceneLoadOrder;

        private void Start()
        {
            LoadScenes();
        }

        public void LoadScenes()
        {
            StartCoroutine(LoadScenesCR());
        }

        private IEnumerator LoadScenesCR()
        {
            for (int i = 0; i < sceneLoadOrder.Count; i++)
            {
                AsyncOperation asyncLoad = SceneManager.LoadSceneAsync(sceneLoadOrder[i], LoadSceneMode.Additive);

                while (!asyncLoad.isDone)
                {
                    yield return null;
                }

                yield return new WaitForEndOfFrame();
            }

            SceneManager.UnloadScene(thisScene);
        }
    }
}
